#include "mainwindow.h"


Calc::Calc(QWidget *parent)
    : QWidget(parent)
    , is_func_with_two_parametrs(false)

{
    res = nullptr;
    create_ordinary_calculator();
}




void Calc::change_type_calculator()
{
    QRadioButton * lcd = qobject_cast<QRadioButton*>(sender());
    if(lcd == nullptr)
    {
        Calc::on_push_delete_button();
    }
    if ( lcd->text() == QString(tr("engineering")) )
    {
        delete_ordinary_calculator();
        create_engineer_calculator();
    }
    if(lcd->text() == QString("usual") )
    {
        delete_engineer_calculator();
        create_ordinary_calculator();
    }
}

void Calc::on_push_number_button()
{
    QPushButton * btn =qobject_cast<QPushButton *>( sender() );
    if(btn == nullptr)
    {
        Calc::on_push_delete_button();
        return ;
    }
    if(res->value() == 0 && !res->smallDecimalPoint())
    {
        res->display( btn->text());
    }
    else
    {
        if(res->smallDecimalPoint() && !QString::number(res->value()).contains('.'))
            res->display(QString::number(res->value()) +"." + btn->text());
        else
            res->display(QString::number(res->value()) + btn->text());
    }
}


void Calc::on_push_operation_button()
{

    if(is_func_with_two_parametrs && res->digitCount() != 0)
    {
        double result ;

        if(func_with_two_parametrs == "log")
        {
            double x = num_vec.back();

            double y = res->value();

            if( y < 0 )
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","cannot be divided by 0");

                on_push_delete_button();
            }

            result = log(y) / log( x );

        }

        else if(func_with_two_parametrs == "x^y")
        {
            double x = num_vec.back();
            double y = res->value();
            result = pow(x,y);
        }

        else
        {
            double x = num_vec.back();

            double y = res->value();

            result = pow(x,1.0/y);

        }

        num_vec.pop_back();

        num_vec.push_back(result);


        QPushButton * btn = qobject_cast<QPushButton*>(sender());

        if(btn == nullptr)
        {
            Calc::on_push_delete_button();
            return ;
        }

        oper_vec.push_back(btn->text());

        res->display("");

        res->setSmallDecimalPoint(false);

        is_func_with_two_parametrs = false;

        return;

    }



    if(num_vec.size() > oper_vec.size())
    {
        QPushButton * btn = qobject_cast<QPushButton*>(sender());

        if(btn == nullptr)
        {
            Calc::on_push_delete_button();
            return ;
        }

        oper_vec.push_back(btn->text());

        res->setSmallDecimalPoint(false);

        return;
    }


    if(res->digitCount() != 0 )
    {

        QPushButton * btn = qobject_cast<QPushButton*>(sender());

        if(btn == nullptr)
        {
            Calc::on_push_delete_button();
            return ;
        }

        num_vec.push_back(res->value());

        oper_vec.push_back(btn->text());

        res->display("");

        res->setSmallDecimalPoint(false);

        return;

    }

}

void Calc::on_push_delete_button()
{
    res->display("");

    res->setSmallDecimalPoint(false);

    is_func_with_two_parametrs = false;

    num_vec.clear();

    oper_vec.clear();

    func_with_two_parametrs = "";

}


void Calc::on_push_dot_button()
{
    if( !res->smallDecimalPoint() && res->value() != cosh(-1) && !QString::number(res->value()).contains('.'))
    {
        res->setSmallDecimalPoint(true);

        res->display(QString::number(res->value()) + ".");
    }


}

void Calc::on_push_equal_button()
{

    if(is_func_with_two_parametrs && res->digitCount() != 0)
    {
        double result ;

        if(func_with_two_parametrs == "log")
        {
            double x = num_vec.back();

            double y = res->value();

            if( y < 0 )
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","cannot be divided by 0");

                on_push_delete_button();
            }

            result = log(y) / log( x );

        }

        if(func_with_two_parametrs == "x^y")
        {
            double x = num_vec.back();

            double y = res->value();

            result = pow(x,y);

        }

        if(func_with_two_parametrs == "x^(1/y)" )
        {
            double x = num_vec.back();

            double y = res->value();

            result = pow(x,1.0/y);

        }

        num_vec.pop_back();

        num_vec.push_back(result);


        res->setSmallDecimalPoint(false);

        is_func_with_two_parametrs = false;

        double result1 =  parser_count(num_vec,oper_vec);

        res->display(result1);

        num_vec.clear();

        oper_vec.clear();



        return;


    }

    if(res->digitCount() == 0 && num_vec.size() == 1)
    {
        res->display(num_vec[0]);

        return;

    }


    if(res->digitCount() != 0)
    {

        num_vec.push_back(res->value());

        double result =  parser_count(num_vec,oper_vec);

        res->display(result);

        num_vec.clear();

        oper_vec.clear();

        return;

    }

}


double Calc::parser_count(QVector<double> numbers, QVector<QString> operations)
{

    if(numbers.size() == 1)
        return numbers[0];

    for(QVector<QString>::Iterator operation = operations.begin() ; operation != operations.end() ; )
    {
        if(*operation == "*" || *operation == "/")
        {
            int index = operation - operations.begin() ;

            double temp = 0;

            if(*operation == "*")
            {
                temp = numbers[index]*numbers[index+1];
            }

            else
            {
                if(numbers[index+1] == 0)
                {
                    QMessageBox * error = new QMessageBox(this);

                    error->warning(this,"Error",tr("cannot be divided by 0"));

                    on_push_delete_button();
                }

                temp = numbers[index]/numbers[index+1];
            }

            operation =  operations.erase(operation);

            numbers[index]= temp;

            QVector<double>::iterator del_iter  = numbers.begin();

            del_iter+=index+1;

            numbers.erase(del_iter);

        }
        else
        {
            ++operation;
        }

    }

    for(QVector<QString>::Iterator operation = operations.begin() ; operation != operations.end() ; )
    {
        int index = 0;

        double temp = 0;

        if(*operation == "+")
        {
            temp = numbers[index] + numbers[index+1];
        }

        else
        {
            temp = numbers[index] - numbers[index+1];
        }

        operation =  operations.erase(operation);

        numbers[index]= temp;

        QVector<double>::iterator del_iter  = numbers.begin();

        del_iter+=index+1;

        numbers.erase(del_iter);

    }

    return numbers[0];

}

void Calc::on_push_math_function_operation()
{
    if(res->digitCount() != 0)
    {
        num_vec.push_back(res->value());

        double value = parser_count(num_vec,oper_vec);

        num_vec.clear();

        oper_vec.clear();

        QPushButton * btn =qobject_cast<QPushButton *>( sender() );

        if(btn == nullptr)
        {
            Calc::on_push_delete_button();
            return ;
        }

        if(btn->text() == "sqrt")
        {
            if(value < 0)
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","It's impossible to take the root of a negative number");

                on_push_delete_button();
            }
            else
                value = sqrt(value);
        }

        if(btn->text() == "1/x")
        {

            if(value == 0)
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error",tr("cannot be divided by 0"));

                on_push_delete_button();
            }
            else
                value = 1/ value;
        }


        if (btn->text() == "sin")
        {
            value = sin(value);
        }

        if( btn->text() == "cos")
        {
            value = cos(value);
        }

        if( btn->text() == "tan")
        {

            value = tan(value);
        }

        if( btn->text() == "sinh")
        {
            value = sinh(value);
        }

        if(btn->text() == "cosh")
        {
            value = cosh(value);
        }

        if (btn->text() == "tanh")
        {
            value = tanh(value);
        }

        if( btn->text() == "ln")
        {
            if(value < 0)
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","domain of LN is  (0 ; +inf) ");

                on_push_delete_button();
            }
            else
                value = log(value);
        }

        if(btn->text() == "exp")
        {
            value = exp(value);
        }

        if (btn->text() == "x^2")
        {
            value= pow(value,2);
        }

        if(btn->text() == "x^3")
        {
            value= pow(value,3);
        }

        if( btn->text() == "x^(1/3)")
        {
            value= pow(value,1.0/3.0);
        }

        if( btn->text() == "n!")
        {
            int temp = 1;
            for(int i = 1 ; i <= value ; i++ )
                temp*=i;

            value = temp;

        }

        num_vec.push_back(value);

        res->display("");

    }
}

void Calc::on_push_pi_button()
{
    if(res->digitCount() == 0  || res->value() == 0)
    {
        double tmp = acos(-1);

        res->display(tmp);
    }

}


void Calc::on_push_math_function_with_two_params()
{
    if(res->digitCount() != 0)
    {

        QPushButton *btn = qobject_cast< QPushButton *>(sender());

        if(btn == nullptr)
        {
            Calc::on_push_delete_button();
            return ;
        }

        if(btn->text() =="log")
        {
            if(res->value() == 1 || res->value() < 0)
            {
                QMessageBox * error = new QMessageBox(this);

                error->warning(this,"Error","base of logarithm is bad. Input base of logarithm, then push the button and input expression under the logarithm");

                on_push_delete_button();
            }
        }

        num_vec.push_back(res->value());

        func_with_two_parametrs = (btn->text());

        res->display("");

        is_func_with_two_parametrs = true;

        res->setSmallDecimalPoint(false);



    }
}




void Calc::create_ordinary_calculator()
{
    grid  = new QGridLayout( this );
    c = new QPushButton("C",this);
    if(res==nullptr)
        res  = (new QLCDNumber(this));
    this->resize(400,600);
    this->setWindowTitle("Калькулятор");
    res->setDigitCount(20);
    res->setMinimumSize(QSize(700,100));
    res->setSegmentStyle(QLCDNumber::Flat);
    grid->addWidget(res,0,0,1,5);
    if(choice_vec.isEmpty())
    {
        choice_vec.push_back( new QRadioButton(tr("usual"),this));

        choice_vec.push_back( new QRadioButton(tr("engineering"), this));
    }

    for(auto r_btn : choice_vec)
    {
        r_btn->setCheckable(true);
    }

    choice_vec[0]->setChecked(true);
    choice_vec[1]->setChecked(false);




    QVBoxLayout * vbox = new QVBoxLayout();

    for(auto r_btn : choice_vec)
    {
        vbox->addWidget(r_btn);
    }

    grid->addLayout(vbox,1,0,1,4);
    c->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    grid->addWidget(c,1,4);
    btn_txt = {"7","8","9","/","sqrt","4","5","6", "*", "1/x","1","2","3","-","=","0",".","+"};
    for(auto b_txt : btn_txt)
    {
        btn_vec.push_back(new QPushButton(b_txt,this));
    }
    for(auto btn : btn_vec)
    {
        btn->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    }

    int line = 4;
    int column = 5;
    for(int i =0 ; i < line - 1 ; i ++)
    {
        for(int j =0 ; j < column  ; j++)
        {
            if(btn_vec[i*column + j]->text() == "=")
            {
                grid->addWidget(btn_vec[i*column + j],i+2,j,2,1);
            }
            else
            {
                grid->addWidget(btn_vec[i*column + j],i+2,j);
            }

        }
    }
    for(int j =0 ; j < column - 2 ;j++)
    {
        if(btn_vec[(line-1)*column + j]->text() == "0")
        {
            grid->addWidget(btn_vec[(line-1)*column + j],line-1 +2,j,1,2);
        }
        else
        {
            grid->addWidget(btn_vec[(line-1)*column + j],line-1+2,j+1);
        }
    }
    for(auto btn : btn_vec)
    {
        if(btn->text() == "0" || btn->text() == "1" || btn->text() == "2" || btn->text() == "3" || btn->text() == "4" || btn->text() == "5" || btn->text() == "6" ||btn->text() == "7" || btn->text() == "8" ||  btn->text() == "9")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_number_button);
        }
        else if(btn->text() ==  "=")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_equal_button);
        }
        else if(btn->text() == ".")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_dot_button);
        }
        else  if(btn->text() == "+" ||btn->text() == "-" ||btn->text() == "*" || btn->text() == "/")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_operation_button);
        }
        else if(btn->text() == "1/x" || btn->text() == "sqrt")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_math_function_operation);
        }
    }
    connect(c,&QPushButton::clicked,this,&Calc::on_push_delete_button);
    connect(choice_vec[0],&QRadioButton::clicked,this, &Calc::change_type_calculator );
    connect(choice_vec[1],&QRadioButton::clicked,this, &Calc::change_type_calculator );
}

void Calc::create_engineer_calculator()
{
    grid =new QGridLayout(this);


    this->resize(1200,800);

    this->setWindowTitle("Калькулятор (инженерный)");
    if(res==nullptr)
        res = new QLCDNumber(this);

    res->setDigitCount(40);

    res->setMinimumSize(QSize(1000,100));

    res->setSegmentStyle(QLCDNumber::Flat);

    grid->addWidget(res,0,0,1,9);

    QVBoxLayout * vbox = new QVBoxLayout();

    for(auto r_btn : choice_vec)
    {
        vbox->addWidget(r_btn);
    }


    grid->addLayout(vbox,1,0,1,8);


    c = new QPushButton (this);

    c->setText("C");

    c->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

    grid->addWidget(c,1,8);

    for(auto b_txt : btn_txt)
    {
        btn_vec.push_back(new QPushButton(b_txt,this));
    }

    for(auto btn : btn_vec)
    {
        btn->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);

    }

    int line = 4;

    int column = 5;

    for(int i =0 ; i < line - 1 ; i ++)
    {
        for(int j =0 ; j < column  ; j++)
        {


            if(btn_vec[i*column + j]->text() == "=")
            {
                grid->addWidget(btn_vec[i*column + j],i+2,j+4,2,1);
            }

            else
            {
                grid->addWidget(btn_vec[i*column + j],i+2,j+4);
            }

        }
    }

    for(int j =0 ; j < column - 2 ;j++)
    {

        if(btn_vec[(line-1)*column + j]->text() == "0")
        {
            grid->addWidget(btn_vec[(line-1)*column + j],line-1 +2,j+4,1,2);
        }

        else
        {
            grid->addWidget(btn_vec[(line-1)*column + j],line-1+2,j+5);
        }

    }

    btn_txt2 ={ "sinh","sin","exp","x^2","cosh","cos","ln","x^3","tanh","tan","log","x^y","n!","pi","x^(1/3)","x^(1/y)"};


    for(auto b_txt : btn_txt2)
    {
        btn_vec2.push_back(new QPushButton(b_txt,this));
    }


    for(auto btn : btn_vec2)
    {
        btn->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);


    }


    int line2 = 4;
    int column2 = 4;

    for(int i = 0 ; i < line2 ; i++)
    {
        for( int j =0 ; j < column2 ; j++)
        {
            grid->addWidget(btn_vec2[i*column2 +j],i+2,j);
        }
    }


    for(auto btn : btn_vec)
    {
        if(
                btn->text() == "0" ||
                btn->text() == "1" ||
                btn->text() == "2" ||
                btn->text() == "3" ||
                btn->text() == "4" ||
                btn->text() == "5" ||
                btn->text() == "6" ||
                btn->text() == "7" ||
                btn->text() == "8" ||
                btn->text() == "9"
                )
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_number_button);
        }

        else if (btn->text() ==  "=")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_equal_button);
        }

        else if(btn->text() == ".")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_dot_button);
        }

        else if(
                btn->text() == "+" ||
                btn->text() == "-" ||
                btn->text() == "*" ||
                btn->text() == "/"
                )
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_operation_button);
        }

        else if(
                btn->text() == "1/x"
                || btn->text() == "sqrt"

                )
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_math_function_operation);
        }

    }
    for(auto btn : btn_vec2)
    {
        if(                      btn->text() == "sin"
                                 || btn->text() == "cos"
                                 || btn->text() == "tan"
                                 || btn->text() == "sinh"
                                 || btn->text() == "cosh"
                                 || btn->text() == "tanh"
                                 || btn->text() == "exp"
                                 || btn->text() == "ln"
                                 || btn->text() == "x^2"
                                 || btn->text() == "x^3"
                                 || btn->text() == "x^(1/3)"
                                 || btn->text() == "n!"
                                 )
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_math_function_operation);
        }

        else if(btn->text() == "pi")
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_pi_button);
        }

        else if(btn->text() == "log"
                || btn->text() == "x^y"
                || btn->text() == "x^(1/y)"
                )
        {
            connect(btn,&QPushButton::clicked,this,&Calc::on_push_math_function_with_two_params);
        }

    }

    connect(c,&QPushButton::clicked,this,&Calc::on_push_delete_button);

    return;
}

void Calc::delete_ordinary_calculator()
{

    QLayoutItem * item = grid->itemAtPosition(0,0);
    choice_vec[1]->hide();
    QWidget* wid = item->widget();

    if(wid)
    {
        grid->removeWidget(wid);

        //delete wid;
    }
    item = grid->itemAtPosition(1,0);

    grid->removeItem(item);




    item = grid->itemAtPosition(1,4);

    wid = item->widget();

    if(wid)
    {
        grid->removeWidget(wid);

        delete wid;
    }


    for( int i = 0 ; i < 3 ; i++  )
    {
        for ( int j = 0 ; j < 5 ; j++)
        {
            item = grid->itemAtPosition(i +2 ,j);

            wid = item->widget();

            if(wid)
            {
                grid->removeWidget(wid);

                delete wid;
            }
        }
    }

    for ( int j = 0 ; j < 4 ; j++)
    {
        if(j != 1)
        {

            item = grid->itemAtPosition(5 ,j);

            wid = item->widget();

            if(wid)
            {
                grid->removeWidget(wid);

                delete wid;
            }
        }
    }

    btn_vec.clear();

    delete grid;
}

void Calc::delete_engineer_calculator()
{
    QLayoutItem * item = grid->itemAtPosition(0,0);
    if(!choice_vec.isEmpty())
        choice_vec[0]->hide();
    QWidget* wid = item->widget();

    if(wid)
    {
        grid->removeWidget(wid);

        //delete wid;
    }

    item = grid->itemAtPosition(1,0);
    grid->removeItem(item);

    item = grid->itemAtPosition(1,8);

    wid = item->widget();

    if(wid)
    {
        grid->removeWidget(wid);

        delete wid;
    }

    for( int i = 0 ; i < 3 ; i++  )
    {
        for ( int j = 0 ; j < 9 ; j++)
        {
            item = grid->itemAtPosition(i +2 ,j);

            wid = item->widget();

            if(wid)
            {
                grid->removeWidget(wid);

                delete wid;
            }
        }
    }

    for(int j = 0 ; j < 5 ; j++)
    {

        item = grid->itemAtPosition(5 ,j);

        wid = item->widget();

        if(wid)
        {
            grid->removeWidget(wid);

            delete wid;
        }
    }

    for(int j = 6 ; j < 8 ; j++)
    {
        item = grid->itemAtPosition(5 ,j);

        wid = item->widget();

        if(wid)
        {
            grid->removeWidget(wid);

            delete wid;
        }
    }

    btn_vec.clear();

    btn_vec2.clear();

    choice_vec.clear();

    delete grid;
}

Calc::~Calc() {}


